namespace ConsoleApp3
{
    internal class Program
    {
        static int Res(int p, int n, int[] a)
        {
            bool t = true;
            int br = 0, max = int.MinValue;
            List<int> b = new List<int>();
            for(int i = p; i < n; i++)
            {
                b.Add(a[i]);
                for (int j = i + 1; j < n; j++)
                {
                    if (a[j] == b.First() || b.Contains(a[j]))
                    {
                        continue;
                    }
                    t = true;
                    foreach(int x in b)
                    {
                        if ((x & a[j]) <= (x ^ a[j]))
                        {
                            t = false;
                            break;
                        }
                    }
                    if (t)
                    {
                        b.Add(a[j]);
                    }
                }
                br = 0;
                for (int j = p; j < n; j++)
                {
                    if (b.Contains(a[j]))
                    {
                        br++;
                    }
                }
                if (br > max)
                {
                    max = br;
                }
                b.Clear();
            }
            return max;
        }
        static void Main(string[] args)
        {
            string[] c = Console.ReadLine().Split();
            int n = int.Parse(c[0]), k = int.Parse(c[1]);
            int[] a = new int[n];
            c = Console.ReadLine().Split();
            for(int i = 0; i < n; i++)
            {
                a[i] = int.Parse(c[i]);
            }
            for(int i = 0; i < k; i++)
            {
                c = Console.ReadLine().Split();
                Console.WriteLine(Res(int.Parse(c[0]), int.Parse(c[1]),a));
            }
        }
    }
}